;Program dla procesora ATMEL 89C2051 lub 89C4051

DISPAD	EQU	07H			;adres "direct" rejestru DISP
DISP	EQU	R7			;rejestr informujcy co wywietla
					;01H - godzina (godziny i minuty)
					;02H - sekundy
					;03H - data (dzie i miesic)
					;04H - temperatura
					;05H - budzik (godziny i minuty)
					;10H - godzina - ustawianie
					;20H - sekundy - ustawianie
					;30H - data - ustawianie
					;50H - budzik - ustawianie
					;wszystkie pozostae - godzina

LICZAD	EQU	06H
LICZNIK	EQU	R6			;wykorzystywany do: migania, ...

BLINK	BIT	00H  			;okrela czy ... ma wieci (1), czy nie (0)
MINVIS	BIT	01H			;widoczny minus ?
FIRST0	BIT	02H			;przy temperaturze trzeba wygasi 2 zera
ALARM	BIT	03H			;budzenie wczone / wyczone
					;aktualny stan brzczka - BUZZER
BLKLEFT	BIT	04H			;1 - miga lewa cyfra, 0 - miga prawa cyfra
BLINK2	BIT	05H			;2x czciej ni BLINK
BUZZON	BIT	06H			;informuje, e jest wczony budzik
EMALRM	BIT	07H			;Emergency Alarm - dobudzanie :)
NEWMIN	BIT	08H			;ustawiany gdy nowa zaczyna si niwa minuta
					;kasowany w momencie wczenie BUZZON

TMSET	BIT	09H			;TIMER TO SET - oczekiwanie na wczenie
					;trybu ustawiania (ok 15 sek. - 32k * 4000us)

SETMODE	BIT	10H			;0 - tryb normalny, 1 - tryb ustawiania

BMODE	BIT	P3.7			;stan przycisku MODE
MODEON	BIT	17H			;zarejestrowano nacinicie MODE
BDATE	BIT	P3.5			;stan przycisku DATE
DATEON	BIT	15H			;zarejestrowano nacinicie DATE
BSEK	BIT	P3.4			;stan przycisku SEK
SEKON	BIT	14H			;zarejestrowano nacinicie SEK

BUZZER	BIT	P3.3			;generator

ADCCS	BIT	P3.2			;przetwornik - wybr ukladu
ADCOUT	BIT	P3.1			;przetwornik - wyjscie szeregowe
ADCCLK	BIT	P3.0			;przetwornik - zegar

MSEK	EQU	08H			;1msek=1/250sek
SEK	EQU	09H
MIN	EQU	0AH
HOUR	EQU	0BH
DAY	EQU	0CH
MONTH	EQU	0DH
ALMIN	EQU	0EH			;budzik - minuty
ALHOUR	EQU	0FH			;budzik - godziny

TEMP0	EQU	12H
TEMP1	EQU	13H

EMHOUR	EQU	30H			;godzina kolejnego budzenia
EMMIN	EQU	31H			;minuty kolejnego budzenia
BUZTRY	EQU	32H			;zlicza prby budzenia

CORL	EQU	34H			;do korekcji czasu
CORH	EQU	35H

RPTTIM	EQU	38H			;licznik - timer do autopowtarzania


;maski wywietlania
DISP3	EQU	00000000B
DISP2	EQU	00010000B
DISP1	EQU	00100000B
DISP0	EQU	00110000B
MINUS	EQU	00000000B		;minus
COMMA	EQU	01000000B		;przecinek
COLON	EQU	10000000B		;dwukropek
DEGREE	EQU	11000000B		;stopnie

	ORG 	0000H
	LJMP 	START
	ORG	000BH  
	AJMP	PROGRAM
	ORG	002BH 

;************** begin ********** inicjalizacja procesora ***************************************
START:
	MOV	TMOD,#00010001B		;TIMER 0 i 1 w trybie 1
	MOV	SP,#3FH			;warto pocztkowa SP
	CALL	RSTALL			;zerowanie rejestrw
	MOV	TL0,#060H
	MOV	TH0,#0F0H		;warto pocztkowa TIMER 0
	SETB	PT0			;wysoki priorytet dla przerwania
	SETB	ET0			;uaktywnienie przerawania z TIMER 0
	SETB	TR0			;start TIMER 0
	SETB	EA			;uaktywnienie mechanizmu przerwa
	SJMP	$			;oczekiwanie na przerwanie z TIMER 0
;************** end ************ inicjalizacja procesora ***************************************

;************** begin ********** ustawianie stanu pocztkowego *********************************
RSTALL:
;zerowanie wszystkich rejestrw - ustawianie wartoci pocztkowych
	CLR	RS0
	CLR	RS1			;zestaw 1 (00)
	CALL	RSTREGS
	MOV	R7,#01H			;na starcie ustaw aby wywietla czas
	SETB	RS0			;zestaw 2 (01)
	CALL	RSTREGS
	MOV	R4,#01H			;ustaw licznik dni na 1
	MOV	R5,#01H			;ustaw licznik miesicy na 1
	SETB	RS1			;zestaw 4 (11)
	CALL	RSTREGS
	CLR	RS0			;zestaw 3 (10)
	CALL	RSTREGS
	CLR	RS1			;zestaw 1 (00)
	CLR	SETMODE			;eby nie strtowa w trybie ustawiania ... a moe jednak
	SETB	BMODE			;wejcie
	SETB	BDATE			;wejcie
	SETB	BSEK			;wejcie
	CLR	BUZZER			;wycz piszczydo
	SETB	ADCCLK			;wyjscie - stan spoczynkowy 1
	SETB	ADCOUT			;wejcie
	SETB	ADCCS			;wyjcie - stan spoczynkowy 1
	MOV	CORL,#4BH
	MOV	CORH,#39H		;14667 - odstpy korekcji
	CLR	ALARM			;bo inaczej od razu krzyczy
	CLR	MODEON			;skasuj przyciski
	CLR	DATEON			;inaczej stany s ...
	CLR	SEKON			;... nieokrelone :)
	RET
RSTREGS:
	MOV	R0,#00H
	MOV	R1,#00H
	MOV	R2,#00H
	MOV	R3,#00H
	MOV	R4,#00H
	MOV	R5,#00H
	MOV	R6,#00H
	MOV	R7,#00H
	RET
;************** end ************ ustawianie stanu pocztkowego *********************************

;************** begin ********** program gwny - obsuga przerwania z timera 0 ****************
PROGRAM:
	ORL	TL0,#060H
	MOV	TH0,#0F0H		;warto pocztkowa TIMER 0
	ACALL	TIME
	CLR	RS0
	CLR	RS1			;przecz na pierwszy bank rejestrw !!!!!
	INC	LICZNIK
	MOV	A,LICZNIK		;aby sprawdzi najstarszy bit
	CLR	BLINK			;skasuj BLINK
	JNB	ACC.7,DALEJ1		;ACC.7=0 to przeskocz
	SETB	BLINK			;ustaw BLINK gdy ACC.7=1
DALEJ1:
	MOV	A,LICZNIK		;aby sprawdzi najstarszy bit
	CLR	BLINK2			;skasuj BLINK
	JNB	ACC.6,DALEJ2		;ACC.6=0 to przeskocz
	SETB	BLINK2			;ustaw BLINK2 gdy ACC.6=1
DALEJ2:
	JB	SETMODE,DALEJ3		;w trybie ustawiania nie wczaj budzika :)
	JNB	BUZZON,DALEJ3		;nie wczony sygna to przeskocz
	JNB	BLINK,DALEJ3		;chwila przerwy
	SETB	BUZZER			;wcz generator
	SJMP	DALEJ4
DALEJ3:
	CLR	BUZZER			;wycz generator
DALEJ4:
	MOV	A,LICZNIK		;aby sprawdz, ktra pozycja jest wywietlana
	ANL	A,#00000011B
	JNZ	CHK01			;tylko przed pierwsz wywietlan cyfr procedura
					;sprawdzania guzikw i zmiany zawartoci DISP
	JB	SETMODE,DOSETMODE	;gdy jest SETMODE to skocz do ...
	JNB	BMODE,CHKALARM
	CLR	TMSET			;nie ma ustawiania to zatrzymaj licznik
	JNB	BSEK,CHKSEK
	JNB	BDATE,DISPDATE
	MOV	DISP,#01H		;wywietl czas
	SJMP	CHK01			;do procedury wywietlania ....
CHKSEK:
	CLR	BUZZON			;wycz budzik
	CLR	EMALRM			;wycz dobudzanie
	JNB	BDATE,DISPTEMP
	MOV	DISP,#02H		;wywietl sekundy
	SJMP	CHK01			;do procedury wywietlania ....
DISPDATE:
	CLR	BUZZON			;wycz budzik
	CLR	EMALRM			;wycz dobudzanie
	MOV	DISP,#03H		;wywietl dat
	SJMP	CHK01			;do procedury wywietlania ....
DISPTEMP:
	MOV	DISP,#04H		;wywietl temperatur
	SJMP	CHK01
CHKALARM:
	CLR	BUZZON			;wycz budzik
	CLR	EMALRM			;wycz dobudzanie
	JB	TMSET,INCTMR
	SETB	TMSET			;ustaw bit TMSET - oczekiwanie na start
	MOV	DPL,#0
	MOV	DPH,#0
INCTMR:	INC	DPTR
	MOV	A,DPH			;eby sprawdzi najstarszy bit
	JB	ACC.1,RUNSET		;przejd do trybu ustawiania 
					;po czasie 512*16ms
	MOV	DISP,#05H		;wywietl godzin budzenia
	SJMP	CHK01			;do procedury wywieltania ....
RUNSET:	SETB	SETMODE			;uaktywnij tryb ustawiania
	MOV	DPL,#0
	MOV	DPH,#0			;szczeglnie tego trzeba wyzerowa
	MOV	18H,#00000100B		;bo inacej od razu wchodzi do ustawiania daty
	MOV	1BH,#1			;R3 na stronie 3 - ustawianie budzika
	MOV	DISP,#50H		;ustawianie budzika
	CLR	BLKLEFT			;miga prawa strona
;***************procedura obsugi trybu ustawiania*****************************************
DOSETMODE:
	ACALL	SETPROC			;przejd do procedury ustawiania :)
CHK01:
	CJNE	DISP,#01H,CHK02
	ACALL	SHOWTIME		;01H -> procedura wywietlania czasu
	SJMP	ENDPROG
CHK02:
	CJNE	DISP,#02H,CHK03
	ACALL	SHOWSEK			;02H -> procedura wywietlania sekund
	SJMP	ENDPROG
CHK03:
	CJNE	DISP,#03H,CHK04
	ACALL	SHOWDATE		;03H -> procedura wywietlania daty
	SJMP	ENDPROG
CHK04:
	CJNE	DISP,#04H,CHK05
	ACALL	SHOWTEMP		;04H -> procedura wywietlania temperatury
	SJMP	ENDPROG
CHK05:
	CJNE	DISP,#05H,CHK10
	ACALL	SHOWALARM
	SJMP	ENDPROG
CHK10:
	CJNE	DISP,#10H,CHK20
	ACALL	SHOWTIME
	SJMP	ENDPROG
CHK20:
	CJNE	DISP,#20H,CHK30
	ACALL	SHOWSEK
	SJMP	ENDPROG
CHK30:
	CJNE	DISP,#30H,CHK50
	ACALL	SHOWDATE
	SJMP	ENDPROG
CHK50:
	CJNE	DISP,#50H,CHKLAST
	ACALL	SHOWALARM
	SJMP	ENDPROG
CHKLAST:
	ACALL	SHOWTIME		;procedura wywietlania czasu
ENDPROG:
		
	RETI				;powrt z obsugi przerwania
;************** end ************ program gwny - obsuga przerwania z tiera 0 *****************

;procedury obsugi wywietlania - przygotowania rejestrw do wywietlania
SHOWTIME:
		;bank rejestrw ustawiony na 0 .....
	MOV	A,LICZNIK
	ANL	A,#00000011B
	CJNE	A,#01H,CHKTM2
	SJMP	DTM1			;=01H
CHKTM2:	CJNE	A,#02H,CHKTM3
	SJMP	DTM2			;=02H
CHKTM3:	CJNE	A,#03H,DTM0
	SJMP	DTM3			;=03H
DTM0:	MOV	R0,MIN			;=00H -> czytaj nowy czas
	MOV	R1,HOUR
	ACALL	ROZBIJ			;w R5 do R2 s cyfry, w  A jest pierwsza
DTM01:	ANL	A,#0FH
	JNZ	DTM02			;do wygaszania zera - gdy nie 0 to przeskocz
	MOV	A,R5			;bo brak informacji o numerze wywietlacza
	ORL	A,#0FH			;1111 -> puste na wyjciu 74247 ...
	SJMP	DTM03
DTM02:	MOV	A,R5
DTM03:	ORL	A,#COLON		;nie moe by MINUS i COMMA
	ACALL	SHOWLEFT
	MOV	P1,A
	RET
DTM1:	MOV	A,R4			;druga cyfra godziny do A
	JNB	BLINK,DTM11		;gdy BLINK=1 to ...
	ORL	A,#COLON		;... wywietl dwukropek
	SJMP	DTM12
DTM11:	ORL	A,#DEGREE		;gdy BLINK=0 to stopie (i tak sie nie zawieci)
DTM12:	ACALL	SHOWLEFT
	MOV	P1,A
	RET
DTM2:	MOV	A,R3			;trzecia cyfra do A
	ORL	A,#DEGREE		;nie moe by MINUS i COMMA
	ACALL	SHOWRIGHT
	MOV	P1,A
	RET
DTM3:	MOV	A,R2			;ostatnia cyfra do A
	JB	SETMODE,DTM31		;w trybie ustawiania kropka zgaszona
	JNB	ALARM,DTM31		;gdy wczony alarm to poka to
	ORL	A,#COMMA		;gdy ALARM ON (kropka)
	SJMP	DTM32
DTM31:	ORL	A,#COLON		;gdy ALARM OFF (nic - dwukropek)
DTM32:	ACALL	SHOWRIGHT
	MOV	P1,A
	RET

SHOWSEK:
		;bank rejestrw ustawiony na 0 .....
	MOV	A,LICZNIK
	ANL	A,#00000011B
	CJNE	A,#01H,CHKSK2
	SJMP	DSK1			;=01H
CHKSK2:	CJNE	A,#02H,CHKSK3
	SJMP	DSK2			;=02H
CHKSK3:	CJNE	A,#03H,DSK0
	SJMP	DSK3			;=03H
DSK0:	MOV	R0,SEK			;=00H -> czytaj sekundy
	MOV	R1,#0FFH		;przy sekundniku nic do wywietlwnia na
					;pocztkowych pozycjach wywietlacza
	ACALL	ROZBIJ			;w R5 do R2 s cyfry, R5 i R4 - 1111 (OFF)
	ORL	A,#COLON		;nie moe by MINUS i COMMA
	MOV	P1,A
	RET
DSK1:	MOV	A,R4			;do A 1111, czyli te OFF
	ORL	A,#COLON		;ale wywietl dwukropek
	MOV	P1,A
	RET
DSK2:	MOV	A,R3			;pierwsza cyfra do A
	ORL	A,#DEGREE		;nie moe by MINUS i COMMA
	ACALL	SHOWRIGHT
	MOV	P1,A
	RET
DSK3:	MOV	A,R2			;druga cyfra do A
	ORL	A,#COLON		;jedyna dopuszczalna moliwo
	ACALL	SHOWRIGHT
	MOV	P1,A
	RET

SHOWDATE:
		;bank rejestrw ustawiony na 0 .....
	MOV	A,LICZNIK
	ANL	A,#00000011B
	CJNE	A,#01H,CHKDT2
	SJMP	DDT1			;=01H
CHKDT2:	CJNE	A,#02H,CHKDT3
	SJMP	DDT2			;=02H
CHKDT3:	CJNE	A,#03H,DDT0
	SJMP	DDT3			;=03H
DDT0:	MOV	R0,DAY			;=00H -> czytaj dzie i miesic
	MOV	R1,MONTH
	ACALL	ROZBIJ			;w R5 do R2 s cyfry, w A dziesitki miesicy
DDT01:	ANL	A,#0FH
	JNZ	DDT02			;do wygaszania zera - gdy nie 0 to przeskocz
	MOV	A,R5			;bo brak informacji o numerze wywietlacza
	ORL	A,#0FH			;1111 -> puste na wyjciu 74247 ...
	SJMP	DDT03
DDT02:	MOV	A,R5			;przelij ponownie dziesitki miesicy
DDT03:	ORL	A,#COLON		;nie moe by MINUS i COMMA
	ACALL	SHOWLEFT
	MOV	P1,A
	RET
DDT1:	MOV	A,R4			;przeslij jednoci miesicy
	ORL	A,#DEGREE		;jedyna dopuszczalna moliwo
	ACALL	SHOWLEFT
	MOV	P1,A
	RET
DDT2:	MOV	A,R3			;przelij dziesitki dni
DDT21:	ANL	A,#0FH
	JNZ	DDT22			;do wygaszania zera - gdy nie 0 to przeskocz
	MOV	A,R3			;bo brak informacji o numerze wywietlacza
	ORL	A,#0FH			;1111 -> puste na wyjciu 74247 ...
	SJMP	DDT23
DDT22:	MOV	A,R3			;przelij ponownie dziesitki dni
DDT23:	ORL	A,#DEGREE		;nie moe by MINUS i COMMA
	ACALL	SHOWRIGHT
	MOV	P1,A
	RET
DDT3:	MOV	A,R2			;;przelij jednoci dni
	ORL	A,#COLON		;jedyna dopuszczalna moliwo
	ACALL	SHOWRIGHT
	MOV	P1,A
	RET

SHOWTEMP:
		;bank rejestrw ustawiony na 0 .....
	MOV	A,LICZNIK
	ANL	A,#00000011B
	CJNE	A,#01H,CHKTP2
	SJMP	DTP1			;=01H
CHKTP2:	CJNE	A,#02H,CHKTP3
	SJMP	DTP2			;=02H
CHKTP3:	CJNE	A,#03H,RDTEMP
	SJMP	DTP3			;=03H
RDTEMP:	ACALL	GETTEMP			;=00H -> uruchom procedur odczytu temperatury
					;w trakcie uywany jest 2-gi bank rejestrw
	CLR	RS0
	CLR	RS1			;przecz na pierwszy bank rejestrw
DTP0:	MOV	R0,TEMP0
	MOV	R1,TEMP1
	ACALL	ROZBIJ			;w R5 do R2 s cyfry
	JB	MINVIS,DTP04		;gdy temperatura < 0
DTP01:	ANL	A,#0FH                  ;temperatura > 0
	JNZ	DTP02			;do wygaszania zera - gdy nie 0 to przeskocz
	SETB	FIRST0			;bdzie potzrbne za chwil
	MOV	A,R5			;bo brak informacji o numerze wywietlacza
	ORL	A,#0FH			;1111 -> puste na wyjciu 74247 ...
	SJMP	DTP03
DTP02:	MOV	A,R5			;przelij ponownie pierwsz cyfr
DTP03:	ORL	A,#COLON		;nie moe by MINUS i COMMA
	MOV	P1,A
	RET
DTP04:	ORL	A,#0FH			;nic nie wywietlaj - czyli max -99,9 (8)
	ORL	A,#MINUS		;wywietl "-"
	MOV	P1,A
	RET
DTP1:	MOV	A,R4			;druga cyfra do A
	JNB	FIRST0,DTP13		;gdy pierwsze nie byo 0 to nieistotne czy
					;na drugiej pozycji jest 0 czy nie
DTP11:	ANL	A,#0FH
	JNZ	DTP12			;do wygaszania zera - gdy nie 0 to przeskocz
	MOV	A,R4			;bo brak informacji o numerze wywietlacza
	ORL	A,#0FH			;1111 -> puste na wyjciu 74247 ...
	SJMP	DTP13
DTP12:	MOV	A,R4			;przelij ponownie drug cyfr
DTP13:	ORL	A,#DEGREE		;nie moe by MINUS i COMMA
	MOV	P1,A
	RET
DTP2:	MOV	A,R3			;trzecia cyfra do A
	ORL	A,#COMMA		;koniecznie, bo temperatura
	MOV	P1,A
	RET
DTP3:	MOV	A,R2			;czwarta cyfra do A
	ORL	A,#DEGREE		;koniecznie, bo temperatura
	MOV	P1,A
	RET

SHOWALARM:
		;bank rejestrw ustawiony na 0 .....
	MOV	A,LICZNIK
	ANL	A,#00000011B
	CJNE	A,#01H,CHKAL2
	SJMP	DAL1			;=01H
CHKAL2:	CJNE	A,#02H,CHKAL3
	SJMP	DAL2			;=02H
CHKAL3:	CJNE	A,#03H,RDSET
	SJMP	DAL3			;=03H
RDSET:	JB	SETMODE,DAL0		;w trybie ustawiania nieustotne (?) stany guzikw
	JB	BDATE,RDCLR   		;=00H -> czytaj ustawienia alarmu i przyciskw
        SETB	ALARM			;zacz wskanik budzika
	CLR	TMSET			;oczekiwanie na SETMODE wyczone
	SJMP	DAL0
RDCLR:	JB	BSEK,DAL0
	CLR	ALARM			;wycz wskanik budzika
	CLR	TMSET			;oczekiwanie na SETMODE wyczone
DAL0:	MOV	R0,ALMIN		;wczytaj ustawiony alarm
	MOV	R1,ALHOUR
	ACALL	ROZBIJ			;w R5 do R2 s cyfry, w  A jest pierwsza
DAL01:	ANL	A,#0FH
	JNZ	DAL02			;do wygaszania zera - gdy nie 0 to przeskocz
	MOV	A,R5			;bo brak informacji o numerze wywietlacza
	ORL	A,#0FH			;1111 -> puste na wyjciu 74247 ...
	SJMP	DAL03
DAL02:	MOV	A,R5
DAL03:	ORL	A,#COLON		;nie moe by MINUS i COMMA
	ACALL	SHOWLEFT
	MOV	P1,A
	RET
DAL1:	MOV	A,R4			;druga cyfra godziny do A
	ORL	A,#COLON		;... wywietl dwukropek
	ACALL	SHOWLEFT
	MOV	P1,A
	RET
DAL2:	MOV	A,R3			;trzecia cyfra do A
	ORL	A,#DEGREE		;nie moe by MINUS i COMMA
	ACALL	SHOWRIGHT
	MOV	P1,A
	RET
DAL3:	MOV	A,R2			;ostatnia cyfra do A
;	JB	SETMODE,DAL30		;w trybie ustawiania zawsz wywietlaj kropk
	JNB	ALARM,DAL31		;gdy wczony alarm to poka to
DAL30:	ORL	A,#COMMA		;gdy ALARM ON (kropka)
	SJMP	DAL32
DAL31:	ORL	A,#COLON		;gdy ALARM OFF (nic - dwukropek)
DAL32:	ACALL	SHOWRIGHT
	MOV	P1,A
	RET

SHOWLEFT:
	JNB	SETMODE,ENDLT		;nie ma trybu ustawiania
	JNB	BLKLEFT,ENDLT		;nie ta liczba miga
	JB	BLINK2,ENDLT		;teraz ma i tak wieci
	ORL	A,#0FH			;wyga liczb
ENDLT:	RET

SHOWRIGHT:
	JNB	SETMODE,ENDRT		;nie ma trybu ustawiania
	JB	BLKLEFT,ENDRT		;nie ta liczba miga
	JB	BLINK2,ENDRT		;teraz ma i tak wieci
	ORL	A,#0FH			;wyga liczb
ENDRT:	RET

;rozdziela na rejestry poszczeglne cyfry danych do wywietlania
ROZBIJ:
	MOV	A,R0
	ANL	A,#0FH
	ORL	A,#DISP3
	MOV	R2,A
	MOV	A,R0
	SWAP	A
	ANL	A,#0FH
	ORL	A,#DISP2
	MOV	R3,A
	MOV	A,R1
	ANL	A,#0FH
	ORL	A,#DISP1
	MOV	R4,A
	MOV	A,R1
	SWAP	A
	ANL	A,#0FH
	ORL	A,#DISP0
	MOV	R5,A			;mimo to w A zostaje cyfra najbardziej z lewej :)
	RET		

;************** begin ********** procedura zliczania czasu *************************************
TIME:
	SETB	RS0
	CLR	RS1			;przeczenie na drugi bank rejestrw
;***********************************************************************************************
;opis rejestrw banku 1 (01)
;R0 - msek (00-249)
;R1 - sek (00-59)
;R2 - min (00-59)
;R3 - hour (0-23)
;R4 - day (1-28, 1-30, 1-31 - zalenie od miesiaca)
;R5 - month (1-12)
;R6 - almin (alarm - 0-59)
;R7 - alhour (alarm - 0-23)
;***********************************************************************************************
	CLR	C			;dla bezpieczestwa :)
	DJNZ	CORL,NOCOR		;bez korekcji
	DJNZ	CORH,NOCOR		;j.w.
	MOV	CORL,#04BH		;trzeba ustawi rejestry korekcji 
	MOV	CORH,#039H		;14667 - odstpy korekcji
					;warto pocztkowa: co ile jednostek trzeba korygowa
					;np: 1sek spnienia na 12h to 1 na 43200 sek. (A8C0H)
					;gdy mniejsze odchyki trzeba uy wicej rejestrw :)
	INC	R0			;korekcja dla zegarka ktry spnia
;	DEC	R0			;korekcja dla zegarka ktry spieszy, nie trzeba 
					;porwnywa z #251, ani z adn dodatkow wartoci
	;milisekundy
NOCOR:	INC	R0			;msek = msek + 1
	CJNE	R0,#251,CORSTD		;moe wystpi gdzy po korekcji byo 250!
	MOV	R0,#1			;od razu trzeba skorygowa
	SJMP	SETSEK			;i doda 1 sekund
CORSTD:	CJNE	R0,#250,TIMEEND		;jeeli msek < 250 to ...
	MOV	R0,#0			;jeeli nie to ...
	;sekuny
SETSEK:	MOV	A,R1
	ADD	A,#1			;sek = sek + 1
	DA	A			;korekcja dziesitna (licznik BCD)
	MOV	R1,A
	CJNE	R1,#60H,TIMEEND		;jeeli sek < 60 to ...
	MOV	R1,#00H
	SETB	NEWMIN			;potrzebne do budzika
	;minuty
	MOV	A,R2
	ADD	A,#1			;min = min + 1
	DA	A			;korekcja dziesitna
	MOV	R2,A
	CJNE	R2,#60H,TIMEEND		;jeeli min < 60 to ...
	MOV	R2,#00H
	;godziny
	MOV	A,R3
	ADD	A,#1			;hour = hour + 1
	DA	A			;korekcja dziesitna
	MOV	R3,A
	CJNE	R3,#24H,TIMEEND		;jeeli hour < 24 to ...
	MOV	R3,#00H
	;dni
	MOV	A,R4
	ADD	A,#1			;day = day + 1
	DA	A                       ;korekcja dziesitna
	MOV	R4,A
	CJNE	R4,#32H,CHKMON2		;bo przy ustawianiu mona ustawi za duo ....
	SJMP	NEWMONTH
CHKMON2:
	CJNE	R5,#02H,CHKMON4		;jezeli month <> 2 (luty)
	CJNE	R4,#29H,TIMEEND		;month = 2 i przekroczono 28 dni ...
	SJMP	NEWMONTH
CHKMON4:
	CJNE	R5,#04H,CHKMON6         ;jezeli month <> 4 (kwiecie)
	CJNE	R4,#31H,TIMEEND		;month = 4 i przekroczono 30 dni ...
	SJMP	NEWMONTH
CHKMON6:
	CJNE	R5,#06H,CHKMON9		;jezeli month <> 6 (czerwiec)
	CJNE	R4,#31H,TIMEEND         ;month = 6 i przekroczono 30 dni ...
	SJMP	NEWMONTH
CHKMON9:
	CJNE	R5,#09H,CHKMON11	;jezeli month <> 9 (wrzesie)
	CJNE	R4,#31H,TIMEEND		;month = 9 i przekroczono 30 dni ...
	SJMP	NEWMONTH
CHKMON11:
	CJNE	R5,#11H,CHKREST		;jezeli month <> 11 (listopad)
	CJNE	R4,#31H,TIMEEND		;month = 11 i przekroczono 30 dni ...
	SJMP	NEWMONTH
CHKREST:
	CJNE	R4,#32H,TIMEEND		;jeeli przekroczono 31 dni ...
NEWMONTH:	
	MOV	R4,#01H
	;miesice
	MOV	A,R5
	ADD	A,#1			;month = month + 1
	DA	A   			;korekcja dziesitna (licznik BCD)
	MOV	R5,A
	CJNE	R5,#13H,TIMEEND		;jeeli month < 13 to ...
	MOV	R5,#01H
TIMEEND:
	JNB	NEWMIN,ALARMEND		;nie nowa minuta - nie sprawdzaj budzika
	JNB	ALARM,ALARMOFF		;nie wczone budzenie - wyjd
	MOV	A,R3
	CJNE	A,ALHOUR,CHKEMALARM	;sprawd dobudzanie
	MOV	A,R2
	CJNE	A,ALMIN,CHKEMALARM	;sprawd dobudzanie
        SETB	BUZZON			;wcz budzenie
	CLR	NEWMIN
	SETB	EMALRM			;wcz dobudzanie
	MOV	BUZTRY,#3		;budzenie 3x dodatkowo
	MOV	EMHOUR,ALHOUR
	MOV	EMMIN,ALMIN
	CALL	NEXTALARM
	SJMP	ALARMEND
CHKEMALARM:
	JNB	EMALRM,ALARMOFF		;dobudzanie zakoczone
	MOV	A,R3
	CJNE	A,EMHOUR,ALARMOFF
	MOV	A,R2
	CJNE	A,EMMIN,ALARMOFF
        SETB	BUZZON			;wcz budzenie
	CLR	NEWMIN
	DJNZ	BUZTRY,SETNEXT
	CLR	EMALRM			;wycz dobudzanie
	SJMP	ALARMEND
SETNEXT:
	SETB	EMALRM			;wcz dobudzanie - nipotrzebnie - i tak jest wczone :)
	CALL	NEXTALARM		;wylicz godzin nastpnego budzenia
	SJMP	ALARMEND
ALARMOFF:
	CLR	BUZZON
ALARMEND:
	RET

NEXTALARM:
	MOV	A,EMMIN
	ADD	A,#5
	DA	A
	MOV	B,A			;na chwil
	CLR	C
	SUBB	A,#60H			;pozwala okreli czy przekroczono 60 min
	JC	EMNEXT
	MOV	EMMIN,A
	MOV	A,EMHOUR
	ADD	A,#1
	DA	A
	CJNE	A,#24H,EMEND
	MOV	A,#00H
EMEND:	MOV	EMHOUR,A
	RET
EMNEXT:	MOV	EMMIN,B
	RET
;************** end ************ procedura zliczania czasu *************************************

;************** begin ********** procedura odczytu temperatury *********************************
GETTEMP:
	CLR	RS0
	SETB	RS1			;przeczenie na trzeci bank rejestrw
;***********************************************************************************************
;opis rejestrw banku 2 (10)
;wynik konwersji: 0...4095 - 12 bitw
;R0 - temperatura - bity  4..0 (xxxxx000)
;   - temperatura - liczba jednoci (0..99)
;R1 - temperatura - bity 11..5 (0xxxxxxx)
;   - temperatura - liczba setek (0..40)
;R2 - cyfra trzecia (0) i druga (1)
;R3 - cyfra pierwsza (2) i informacje o znaku lub zerowa :)
;R4, R5 - uywane tymczasowo (licznik, jednoci)
;R6, R7 - tymczasowe wartoci modszych 5(4) i starszych 7 bitw
;***********************************************************************************************
	CLR	C			;dla bezpieczestwa :)
;***************************** odczyt przetwornika A/C *****************************************
	CLR	ADCCS			;rozpocznij konwersj
	NOP
	NOP
	CLR	ADCCLK
	NOP
	NOP
	SETB	ADCCLK			;NOP - zalenoci czasowe, fmax=200kHz
	NOP
	NOP
	CLR	ADCCLK			;1,5 cyklu pustego - DOUT gotowe do pracy
        MOV	A,#0			;wyzeruj akumulator
	CLR	C
	MOV	R4,#4
READ1:	SETB	ADCCLK
	RL	A
	NOP
	CLR	ADCCLK
	MOV	C,ADCOUT
	MOV	ACC.0,C
        DJNZ	R4,READ1
	MOV	R7,A			;zapamietaj 4 starsze bity
        MOV	A,#0			;wyzeruj akumulator
	CLR	C
	MOV	R4,#8
READ2:	SETB	ADCCLK
	RL	A
	NOP
	CLR	ADCCLK
	MOV	C,ADCOUT
	MOV	ACC.0,C
        DJNZ	R4,READ2
;	CLR	ACC.0			;zmniejszoana o 1 bit dokadno
	MOV	R6,A			;zapamitaj 8 modszych bitw
	SETB	ADCCLK			;CLK=1 - pozycja spoczynkowa
	SETB	ADCCS			;CS=1 - koniec konwersji, oczekiwanie na nastpn
;*************************** urednianie wyniku z 8 16 pomiarw ********************************
	MOV	A,LICZAD		;licznik na innej stronie rejestrw
	ANL	A,#00111100B		;maska na xx0000xx
	JNZ	RDNEXT			;gdy nie zero nie zeruj sumy czsciowej
	MOV	R1,#0
	MOV	R0,#0
RDNEXT: CLR	C			;na wszelki wypadek
	MOV	A,R0			;R0 - suma czciowa
	ADD	A,R6			;R6 - aktualny odczytany wynik
	MOV	R0,A
	MOV	A,R1
	ADDC	A,R7
	MOV	R1,A
	CLR	C
	MOV	A,LICZAD
	CPL	A
	ANL	A,#00111100B		;maska na xx1111xx (CPL)
	JNZ	TEMPEND			;gdy nie zero nie wyliczaj nowej wartoci
	CLR	C
	MOV	A,R1
	RRC	A
	MOV	R1,A			;7 starszych w R1
	MOV	A,R0
	RRC	A
;	ANL	A,#0F0H			;dokadno zmniejszona o 1 bit
	MOV	R0,A			;5 modszych w R0
	CLR	C
;************************ korekcja o napicie odniesienia czujnika *****************************
	MOV	A,R1
	JB	ACC.6,NEGBIT
	SETB	MINVIS			;temperatura <= 0
	CLR	C
	MOV	A,#00000000B
	SUBB	A,R0
	MOV	R0,A	
	MOV	A,#01000000B
	SUBB	A,R1
	MOV	R1,A
	SJMP	CONV
NEGBIT:	CLR	MINVIS
	MOV	A,R1			;temperatura > 0
	CLR	ACC.6
	MOV	R1,A
;************************** rozbicie na setki i jednoci ***************************************
CONV:	MOV	A,R1
	MOV	R4,#6			;licznik
	MOV	R1,#0			;tu bdzie nowy wynik
CONV1:	MOV	B,A
	CLR	C
	SUBB	A,#100			;po odjciu gdy C=1 => A<100
	XCH	A,R1			;wczytaj aktualny wynik i zapamitaj A
	RL	A
	MOV	ACC.0,C
	CPL	ACC.0			;bo gdy 1 to wpisa 0 i odwrotnie
	XCH	A,R1			;zapisz wynik, przywr A
	JC	CONV2			;zaoenie: C stay od SUBB
	MOV	R5,A
	RL	A			;zasady odejmowania na kartce :)
	SJMP	CONV3
CONV2:	MOV	A,B			;A byo za mae, zasady ....
	MOV	R5,A
	RL	A
CONV3:	CLR	C
	XCH	A,R0			;zapamitaj A
	RLC	A			;najstarszy bit do C
	XCH	A,R0			;przywr A
	MOV	ACC.0,C			;i dopisz to co byo w R0
	DJNZ	R4,CONV1
	MOV	A,R5			;tam by wynik czstkowy
	MOV	R0,A
;************************* rozbicie na kolejne cyfry *******************************************
	MOV	B,#10
	DIV	AB
	SWAP	A
	ORL	A,B
	MOV	R2,A
	MOV	A,R1
	MOV	B,#10
	DIV	AB
	SWAP	A
	ORL	A,B
	MOV	R3,A
TEMPEND:
	RET
;************** end ************ procedura odczytu temperatury *********************************

;************* begin *********** procedura ustawiania zagraka **********************************
;R0 - stan automatu MODE
;R1 - stan automatu DATE
;R2 - stan automatu SEK
;przyciski s traktowane priorytetowo - trzeba co z tym zrobi
;stany pracy automatw, 3 razy to samo to zmiana
;GRUPA1 - przed ON
;A - 000 : 1 -> A, 0 -> B
;B - 001 : 1 -> A, 0 -> C
;C - 010 : 1 -> A, 0 -> D
;D - 011 : ustaw guzik i +1 (bez kontroli) -> E (04H)
;GRUPA2 - przed OFF
;E - 100 : 0 -> E, 1 -> F
;F - 101 : 0 -> E, 1 -> G
;G - 110 : 0 -> E, 1 -> H
;H - 111 - ustaw guzik i +1 (bez kontroli) -> A (00H)
;R3 - stan procedury ustawiania
;1 - ustawianie alarmu - minuty
;2 - ustawianie alarmu - godziny
;3 - ustawianie daty - dzie
;4 - ustawianie daty - miesic
;5 - ustawianie czasu - minuty
;6 - ustawianie czasu - godziny
;7 - ustawianie czasu - sekundy
;R4 - tymczasowo na miesic
;***********************************************************************************************
SETPROC:
 	SETB	RS1
	SETB	RS0			;przejd na stron 3
;********************** czytanie guzikw *******************************************************
BMODE0:	MOV	A,R0
	ANL	A,#00000100B		;sprawdzanie grupy
	JNZ	BMODE2
	JB	BMODE,BMODE1		;0 -> wcinity, 1 -> spoczynkowy
	INC	R0                      ;operacje dla grupy 1
	MOV	A,R0			
	CPL	A			;wtedy xxxxxxx11->xxxxxx00
	ANL	A,#00000011B		;sprawdzanie stanu
	JNZ	ENDST1			;stan oczekiwania na BMODE ON, nie sprawdzaj innych 
					;powinno by JNZ ENDSET, ale to za daleko !!!!! :( 
        SETB	MODEON
	MOV	R0,#04H			;przejd do grupy 2
	SJMP	ENDSET			;nacinity BMODE, opu procedur
BMODE1:	MOV	R0,#00H
	SJMP	BDATE0
BMODE2:	JNB	BMODE,BMODE3		;0 -> wcinity, 1 -> spoczynkowy
	INC	R0                      ;operacje dla grupy 2
	MOV	A,R0			
	CPL	A			;wtedy xxxxxx111->xxxxx000
	ANL	A,#00000111B		;sprawdzanie stanu
	JNZ	ENDSET			;stan oczekiwania na BMODE OFF, nie sprawdzaj innych
        CLR	MODEON
	MOV	R0,#00H			;przejd do grupy 1
	SJMP	BDATE0			;puszczono BMODE, mona sprawdzi nastpny
BMODE3:	MOV	R0,#04H
ENDST1:	SJMP	ENDSET			;nacinity BMODE, opu procedur

BDATE0:	MOV	A,R1
	ANL	A,#00000100B		;sprawdzanie grupy
	JNZ	BDATE2
	JB	BDATE,BDATE1		;0 -> wcinity, 1 -> spoczynkowy
	INC	R1                      ;operacje dla grupy 1
	MOV	A,R1			
	CPL	A			;wtedy xxxxxxx11->xxxxxx00
	ANL	A,#00000011B		;sprawdzanie stanu
	JNZ	ENDSET			;stan oczekiwania na BDATE ON, nie sprawdzaj innych
        SETB	DATEON
	MOV	R1,#04H			;przejd do grupy 2
	SJMP	ENDSET			;nacinity BDATE, opu procedur
BDATE1:	MOV	R1,#00H
	SJMP	BSEK0
BDATE2:	JNB	BDATE,BDATE3		;0 -> wcinity, 1 -> spoczynkowy
	INC	R1			;operacje dla grupy 2
	MOV	A,R1			
	CPL	A			;wtedy xxxxxx111->xxxxx000
	ANL	A,#00000111B		;sprawdzanie stanu
	JNZ	ENDSET			;stan oczekiwania na BDATE OFF, nie sprawdzaj innych
        CLR	DATEON
	MOV	R1,#00H			;przejd do grupy 1
	SJMP	BSEK0			;puszczono BDATE, mona sprawdzi nastpny
BDATE3:	MOV	R1,#04H
	SJMP	ENDSET			;nacinity BDATE, opu procedur
	
BSEK0:	MOV	A,R2
	ANL	A,#00000100B		;sprawdzanie grupy
	JNZ	BSEK2
	JB	BSEK,BSEK1		;0 -> wcinity, 1 -> spoczynkowy
	INC	R2                      ;operacje dla grupy 1
	MOV	A,R2			
	CPL	A			;wtedy xxxxxxx11->xxxxxx00
	ANL	A,#00000011B		;sprawdzanie stanu
	JNZ	ENDSET			;stan oczekiwania na BSEK ON, nie sprawdzaj innych
	MOV	R2,#04H			;przejd do grupy 2
	MOV	RPTTIM,#128		;128*16ms=2,048s - do uruchomienia autopowtarzania
        SETB	SEKON
	SJMP	ENDSET			;nacinity BSEK, opu procedur
BSEK1:	MOV	R2,#00H
	SJMP	ENDSET
BSEK2:	JNB	BSEK,BSEK3		;0 -> wcinity, 1 -> spoczynkowy
	INC	R2                      ;operacje dla grupy 2
	MOV	A,R2			
	CPL	A			;wtedy xxxxxx111->xxxxx000
	ANL	A,#00000111B		;sprawdzanie stanu
	JNZ	ENDSET			;stan oczekiwania na BSEK OFF, nie sprawdzaj innych
        CLR	SEKON
	MOV	R2,#00H			;przejd do grupy 1
	SJMP	ENDSET			;puszczono BSEK - nic nie nacinito :)
BSEK3:	MOV	R2,#04H
	DJNZ	RPTTIM,ENDSET		;gdy licznik >0 to kontynuuj
	MOV	RPTTIM,#8		;kolejne powtrzenie za 8*16ms=128ms - 8 na sekund
	SETB	SEKON
;************** reakcje na nacinicia guzikw *************************************************
ENDSET:	CLR	C			;na wszelki wypadek
SET1:	CJNE	R3,#1,SET2
	JNB	MODEON,SET11
	CLR	MODEON			;wyczy
	MOV	R3,#3			;MODEON=1 -> przejd do ustawiania daty
	MOV	DISPAD,#30H		;wywietlanie daty
	CLR	BLKLEFT			;miga prawa
	AJMP	ENDPROCSET
SET11:	JNB	DATEON,SET12
	CLR	DATEON			;wyczy
	SETB	ALARM			;zmiana - uaktywnienie alarmu
	SETB	BLKLEFT			;miga lewa strona
	MOV	R3,#2
	AJMP	ENDPROCSET
SET12:	JNB	SEKON,SET14		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	SETB	ALARM			;zmiana - uaktywnienie alarmu
	MOV	A,ALMIN
	ADD	A,#1			;almin = almin + 1
	DA	A			;korekcja dziesitna
	CJNE	A,#60H,SET13		;jeeli almin < 60 to ...
	MOV	A,#00H
SET13:	MOV	ALMIN,A
SET14:	AJMP	ENDPROCSET

SET2:	CJNE	R3,#2,SET3
	JNB	MODEON,SET21
	CLR	MODEON			;wyczy
	MOV	R3,#3			;MODEON=1 -> przejd do ustawiania daty
	MOV	DISPAD,#30H		;wywietlanie daty
	CLR	BLKLEFT			;miga prawa
	AJMP	ENDPROCSET
SET21:	JNB	DATEON,SET22
	CLR	DATEON			;wyczy
	SETB	ALARM			;zmiana - uaktywnienie alarmu
	CLR	BLKLEFT			;miga prawa strona
	MOV	R3,#1
	AJMP	ENDPROCSET
SET22:	JNB	SEKON,SET24		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	SETB	ALARM			;zmiana - uaktywnienie alarmu
	MOV	A,ALHOUR
	ADD	A,#1			;almin = almin + 1
	DA	A			;korekcja dziesitna
	CJNE	A,#24H,SET23		;jeeli alhour < 24 to ...
	MOV	A,#00H
SET23:	MOV	ALHOUR,A
SET24:	AJMP	ENDPROCSET

SET3:	CJNE	R3,#3,SET4
	JNB	MODEON,SET31
	CLR	MODEON			;wyczy
	MOV	R3,#5			;MODEON=1 -> przejd do ustawiania czasu
	MOV	DISPAD,#10H		;wywietlanie czasu
	CLR	BLKLEFT			;miga prawa
	AJMP	ENDPROCSET
SET31:	JNB	DATEON,SET32
	CLR	DATEON			;wyczy
	SETB	BLKLEFT			;miga lewa strona
	MOV	R3,#4
	AJMP	ENDPROCSET
SET32:	JNB	SEKON,SET34		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	MOV	R4,MONTH		;bdzie potrzebne :(
	MOV	A,DAY
	ADD	A,#1			;day = day + 1
	DA	A                       ;korekcja dziesitna
	CJNE	R4,#02H,SMON4		;jezeli month <> 2 (luty)
	CJNE	A,#29H,SET33		;month = 2 i przekroczono 28 dni ...
	SJMP	SNEWM
SMON4:	CJNE	R4,#04H,SMON6		;jezeli month <> 4 (kwiecie)
	CJNE	A,#31H,SET33		;month = 4 i przekroczono 30 dni ...
	SJMP	SNEWM
SMON6:	CJNE	R4,#06H,SMON9		;jezeli month <> 6 (czerwiec)
	CJNE	A,#31H,SET33		;month = 6 i przekroczono 30 dni ...
	SJMP	SNEWM
SMON9:	CJNE	R4,#09H,SMON11		;jezeli month <> 9 (wrzesie)
	CJNE	A,#31H,SET33		;month = 9 i przekroczono 30 dni ...
	SJMP	SNEWM
SMON11:	CJNE	R4,#11H,MREST		;jezeli month <> 11 (listopad)
	CJNE	A,#31H,SET33		;month = 11 i przekroczono 30 dni ...
	SJMP	SNEWM
MREST:	CJNE	A,#32H,SET33		;jeeli przekroczono 31 dni ...
SNEWM:	MOV	A,#01H
SET33:	MOV	DAY,A
SET34:	AJMP	ENDPROCSET

SET4:	CJNE	R3,#4,SET5
	JNB	MODEON,SET41
	CLR	MODEON			;wyczy
	MOV	R3,#5			;MODEON=1 -> przejd do ustawiania czasu
	MOV	DISPAD,#10H		;wywietlanie czasu
	CLR	BLKLEFT			;miga prawa
	AJMP	ENDPROCSET
SET41:	JNB	DATEON,SET42
	CLR	DATEON			;wyczy
	CLR	BLKLEFT			;miga lewa strona
	MOV	R3,#3
	AJMP	ENDPROCSET
SET42:	JNB	SEKON,SET44		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	MOV	A,MONTH
	ADD	A,#1			;month = month + 1
	DA	A			;korekcja dziesitna
	CJNE	A,#13H,SET43		;jeeli month < 13 to ...
	MOV	A,#00H
SET43:	MOV	MONTH,A
SET44:	AJMP	ENDPROCSET

SET5:	CJNE	R3,#5,SET6
	JNB	MODEON,SET51
	CLR	MODEON			;wyczy
	AJMP	SETLAST			;wyjd z trybu ustawiania
SET51:	JNB	DATEON,SET52
	CLR	DATEON			;wyczy
	SETB	BLKLEFT			;miga lewa strona
	MOV	R3,#6
	AJMP	ENDPROCSET
SET52:	JNB	SEKON,SET54		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	MOV	A,MIN
	ADD	A,#1			;min = min + 1
	DA	A			;korekcja dziesitna
	CJNE	A,#60H,SET53		;jeeli min < 60 to ...
	MOV	A,#00H
SET53:	MOV	MIN,A
SET54:	AJMP	ENDPROCSET

SET6:	CJNE	R3,#6,SET7
	JNB	MODEON,SET61
	CLR	MODEON			;wyczy
	AJMP	SETLAST			;wyjd z trybu ustawiania
SET61:	JNB	DATEON,SET62
	CLR	DATEON			;wyczy
	CLR	BLKLEFT			;miga prawa strona
	MOV	R3,#7
	MOV	DISPAD,#20H		;sekundy
	AJMP	ENDPROCSET
SET62:	JNB	SEKON,SET64		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	MOV	A,HOUR
	ADD	A,#1			;almin = almin + 1
	DA	A			;korekcja dziesitna
	CJNE	A,#24H,SET63		;jeeli hour < 24 to ...
	MOV	A,#00H
SET63:	MOV	HOUR,A
SET64:	AJMP	ENDPROCSET

SET7:	CJNE	R3,#7,SETLAST
	JNB	MODEON,SET71
	CLR	MODEON			;wyczy
	AJMP	SETLAST			;wyjd z trybu ustawiania
SET71:	JNB	DATEON,SET72
	CLR	DATEON			;wyczy
	CLR	BLKLEFT			;miga prawa strona
	MOV	R3,#5
	MOV	DISPAD,#10H		;sekundy
	AJMP	ENDPROCSET
SET72:	JNB	SEKON,SET73		;bez zmian -> wyjd z procedury
	CLR	SEKON			;wyczy
	MOV	MSEK,#0			;zeruj msek
	MOV	SEK,#0			;zeruj sek
SET73:	AJMP	ENDPROCSET

SETLAST:
	CLR	SETMODE			;wystpi problem - arbitralne wyjcie z ustawiania
	MOV	DISP,#01H		;i wywietlanie czasu
ENDPROCSET:	
 	CLR	RS1
	CLR	RS0			;wr na stron 0
	RET
;************** end ************ procedura ustawiania zagraka **********************************
	DB	'Created by: Marcin Kucharczyk, marcinkk@wp.pl, '
	DB	'Politechnika Slaska, Gliwice 2001. All rights reserved.'
	END
